#include <sourcemod>
#include <sdktools>

new Float:checkpoint[MAXPLAYERS+1][3];
new tele[MAXPLAYERS+1];
new save[MAXPLAYERS+1]; 
new Handle:sm_maxsave = INVALID_HANDLE;
new maxsave = 0;
new Handle:sm_maxtele = INVALID_HANDLE;
new maxtele = 0;
new Handle:sm_tag = INVALID_HANDLE;

public Plugin:myinfo =
{
	name = "CheckPoints",
	author = "Darkeneez",
	description = "CheckPoint сохранение и телепортация по координатам",
	version = "1.3",
	url = "http://Servers-info.ru"
};

public OnPluginStart() 
{ 
 LoadTranslations("checkpoints.phrases.txt");
 RegConsoleCmd("csave", cmd_csave);
 RegConsoleCmd("ctele", cmd_tele);
 sm_maxsave = CreateConVar("sm_maxsave", "1", "Максимальное количество сохранений/ The maximum number of stored");
 maxsave = GetConVarInt(sm_maxsave);
 HookConVarChange(sm_maxsave, Setting);
 sm_maxtele = CreateConVar("sm_maxtele", "1", "Максимальное количество телепортаций/ The maximum number of teleportation");
 maxtele = GetConVarInt(sm_maxtele);
 HookConVarChange(sm_maxtele, Setting);
 sm_tag = CreateConVar("sm_tag", "[Servers-Info.Ru]", "Тег плагина/ tag plugin it look as: [Servers-Info.Ru] Teleported");
 
 HookEvent("player_spawn", OnPlayer_Spawn);
 
 AutoExecConfig(true, "checkpoint");
} 

public Setting(Handle:convar, const String:oldValue[], const String:newValue[])
{
 if (convar == sm_maxsave)
 {
 maxsave = GetConVarInt(sm_maxsave);
 }
 else if (convar == sm_maxtele)
 {
 maxtele = GetConVarInt(sm_maxtele);
 }
}

public OnClientAuthorized(client)
{
 Keys_create(client);
}

Keys_create(client)
{
	save[client] = 0;
	checkpoint[client][0] = 0.0;
	checkpoint[client][1] = 0.0;
	checkpoint[client][2] = 0.0;
}

public OnPlayer_Spawn(Handle:event, const String:name[], bool:dontBroadcast)
{
 new client = GetClientOfUserId(GetEventInt(event, "userid"));
 save[client] = 0;
 tele[client] = 0;
 checkpoint[client][0] = 0.0;
 checkpoint[client][1] = 0.0;
 checkpoint[client][2] = 0.0;
 decl String:stag[255]; 
 GetConVarString(sm_tag, stag, sizeof(stag));
 PrintToChat(client, "\x03%t\x01", "reset", stag); 
}

public Action:cmd_csave(client, args)
{
 decl String:stag[255]; 
 GetConVarString(sm_tag, stag, sizeof(stag));
 if(save[client] < maxsave)
 {
  if (IsPlayerAlive(client))
  {
   GetEntPropVector(client, Prop_Send, "m_vecOrigin", checkpoint[client]);
   PrintToChat(client, "%t \x03[\x04%t\x03]", stag, "save");
   save[client]++;
  }
  else
  {
   PrintToChat(client, "\x03%t\x01", "must_be_alive", stag);
  }
 }
 else
 {
 PrintToChat(client, "\x03%t\x01", "max_save", stag);
 }
 return Plugin_Handled;
}

public Action:cmd_tele(client, args)
{
 decl String:stag[255]; 
 GetConVarString(sm_tag, stag, sizeof(stag));
 if(tele[client] <  maxtele)
 {
  if (IsPlayerAlive(client))
  {
   if (tele[client] < maxtele)
   if(save[client] > 0)
   { 
   {
   TeleportEntity(client, checkpoint[client], NULL_VECTOR, NULL_VECTOR);
   PrintToChat(client, "\x03%t\x01", "teleported", stag);
   tele[client]++;  
   }
   }
   else
   {
   PrintToChat(client, "\x03%t\x01", "dont_save", stag);
   }
  }
  else
  {
  PrintToChat(client, "\x03%t\x01", "must_be_alive", stag);
  }
 }
 return Plugin_Handled;
}